<?php

/**************
 * ADMIN *********ADMIN ACTION HOOK****************ADMIN
 * ACTION HOOK CONTROL
 * TO CONTROL SOMETHING FROM MAIN MODULE 
 */

$WPT_Module =  WP_PLUGIN_DIR . WPTP_PLUGIN;// Our Main Plugin'woo-product-table/woo-product-table.php';
if( file_exists( $WPT_Module ) ){
   include_once $WPT_Module;
}

if( !function_exists( 'wpt_pro_admin_form_top' ) ){
    /**
     * Docs and Support Link to Our Form Top
     */
    function wpt_pro_admin_form_top(){
        global $post;
        /**
         * @Hook Filter: wpt_admin_form_top_links
         * To Disable Top Links of Get pro, Documentation at the top of our Forms
         * @return Boolean True to displa link, false to hide links from the top of our Admin Post Edit form
         */
        $validation = apply_filters( 'wpt_admin_form_top_links', true, $post );
        if( $validation ){
        ?>
        <ul class="wpt_admin_form_links" style="margin: 0">
            <li><a class="wpt_get_pro_form_top_link" target="_blank" href="https://www.wcproducttable.xyz/docs/">Basic Helps</a></li>
            <li><a target="_blank" href="https://www.wcproducttable.xyz/demo-list/">Demo</a></li>
            
            <li><a target="_blank" href="https://doc.codeastrology.com/woo-product-table-pro/#intro">Documentation</a></li>
            <li><a target="_blank" href="https://codeastrology.com/support/">Get Support</a></li> 
            <li><a target="_blank" href="https://codeastrology.com/support/forums/forum/woo-product-table-pro-making-quick-order-table/">Forum</a></li>

        </ul>    
        <?php
        }
    }
}
add_action( 'wpto_form_top', 'wpt_pro_admin_form_top' );
remove_action( 'wpto_form_top','wpt_admin_form_top' );


if( !function_exists( 'wpt_pro_configuration_page_extra' ) ){
    function wpt_pro_configuration_page_extra( $settings,$current_config_value ){
        if( !isset( $settings['page'] ) || isset( $settings['page'] ) && $settings['page'] != 'configuration_page' ){
            return;
        }
        ?>
        <div class="section ultraaddons-panel top_secion configuration_page">
        <table class="ultraaddons-table">
            <tr>
                <th>
                    <label class="wpt_label wpt_advance_search_on_of" for="wpt_table_head_enable"><?php esc_html_e( 'Advance Search', 'wpt_pro' );?></label>
                </th>
                <td>
                    <label class="switch">
                        <input  name="data[advance_search]" type="checkbox" id="wpt_advance_search_on_of" <?php echo isset( $current_config_value['advance_search'] ) ? 'checked="checked"' : ''; ?>>
                        <div class="slider round"><!--ADDED HTML -->
                            <span class="on">On</span><span class="off">Off</span><!--END-->
                        </div>
                    </label>
                    <p><?php echo esc_html( 'To search By any Title, Custom Field, Taxonomy. Use this feature. If you want to search by any specific item, such: sku, id, custom_field, Go to [Search and Filter] tab: Edit Product Table -> Edit ->', 'wpt_pro' ); ?></p>
                                    
                </td>
            </tr>
            <tr>
                <th>
                    <label class="wpt_label wpt_column_sorting_on_off" for="wpt_column_sorting_on_off"><?php esc_html_e( 'Table Column Sorting', 'wpt_pro' );?></label>
                </th>
                <td>
                    <label class="switch">
                        <input  name="data[column_sort]" type="checkbox" id="wpt_column_sorting_on_off" <?php echo isset( $current_config_value['column_sort'] ) ? 'checked="checked"' : ''; ?>>
                        <div class="slider round"><!--ADDED HTML -->
                            <span class="on">On</span><span class="off">Off</span><!--END-->
                        </div>
                    </label>
                    <p><?php echo esc_html( 'Column sorting for Table Column', 'wpt_pro' ); ?></p>
                                    
                </td>
            </tr>
        </table>
        <div class="ultraaddons-button-wrapper">
            <button name="configure_submit" class="button-primary primary button">Save All</button>
        </div>
    </div>
            
         <?php
    }
}
add_action( 'wpto_admin_configuration_form_top', 'wpt_pro_configuration_page_extra',50,2 );


if( !function_exists( 'wpt_pro_configuration_page_head' ) ){
    function wpt_pro_configuration_page_head(){
        ?>
        <div class="fieldwrap ultraaddons-head">
            <div class="ultraaddons-panel">
                <h1 class="wp-heading-inline plugin_name plugin-name"><?php echo WOO_Product_Table::getName(); ?> <span class="plugin-version">v <?php echo WOO_Product_Table::getVersion(); ?></span></h1>
                <h1 class="plugin-settings with-background no-top slim-title"><?php esc_html_e( 'Common Configuration', 'wpt_pro' );?></h1>
                <p><?php esc_html_e( 'Remember: Each product table has indivisual configuration, wheich is First Importance. But to This Configuration has no "First importance".', 'wpt_pro' );?></p>
            </div>
        </div>    
            
         <?php
    }
}
add_action( 'wpto_admin_configuration_head', 'wpt_pro_configuration_page_head',50 );
remove_action( 'wpto_admin_configuration_head', 'wpt_configuration_page_head',10 );


if( !function_exists( 'wpt_pro_configuration_page_version_data' ) ){
    
    /**
     * To add Version Data, I mean: Version Numbewr and Plugin name as Hidden Input
     * At the top of Configuration Page and Configuration Tab
     * 
     * @since 2.7 and 7.0.0
     */
    function wpt_pro_configuration_page_version_data(){
        ?>
        <input name="data[plugin_version]" type="hidden" value="<?php echo WOO_Product_Table::getVersion(); ?>">
        <input name="data[plugin_name]" type="hidden" value="<?php echo WOO_Product_Table::getName(); ?>"> 
            
         <?php
    }
}
add_action( 'wpto_admin_configuration_form_version_data', 'wpt_pro_configuration_page_version_data' );
remove_action( 'wpto_admin_configuration_form_version_data', 'wpt_configuration_page_version_data' );

if( !function_exists( 'wpt_pro_add_label_acf_column' ) ){
    
    /**
     * Add a new Field for Type Column: Advance Custom Field
     * Normally some time need an Extra text, I mean: Label text
     * Specially for Button
     * Such Download Button
     * Need Taxt for Download Button
     * 
     * @param type $keyword
     * @param type $column_settings
     * return Void
     */
    function wpt_pro_add_label_acf_column( $keyword, $column_settings){
        $this_settings = isset( $column_settings[$keyword] ) ? $column_settings[$keyword] : false;
        if( $this_settings && isset( $this_settings['type'] ) && $this_settings['type'] == 'acf' ){
        $label_text = isset( $column_settings[$keyword]['label_text'] ) ? $column_settings[$keyword]['label_text'] : false;
       ?>
        <label><?php echo esc_html__( 'Extra Label Text (Optionals)', 'wpt_pro' ); ?></label>
        <input class="ua_input" type="text" name="column_settings[<?php echo esc_attr( $keyword ); ?>][label_text]" value='<?php echo esc_attr( $label_text ); ?>'>
        <p>Suppose: You have added file type, then need Download button. For this button text, you can use <b>Extra Label Text</b></p>
        
       <?php
        }
    }
}
add_action( 'wpto_column_setting_form', 'wpt_pro_add_label_acf_column', 10, 2 );

if( !function_exists( 'wpto_pro_product_incld_excld_basic_tab' ) ){
    
    /**
     * Displaying Products list by Select2 and 
     * for Product Includes, 
     * 
     * @global type $product
     * @global type $product
     * @param type $meta_basics
     */
    function wpto_pro_product_incld_excld_basic_tab( $meta_basics ){
   $args = isset( $meta_basics['post_include'] ) ? $meta_basics['post_include'] : false;
   $post_include = wpt_product_includes_select_option($args);

   $args= isset( $meta_basics['post_exclude'] ) ? $meta_basics['post_exclude'] : false;
   $post_exclude = wpt_product_includes_select_option($args);
       ?>

    
    <div class="wpt_column">
        <table class="ultraaddons-table">
            <tr>
                <th>
                    <label class="wpt_label"><?php esc_html_e( 'Product Includes', 'wpt_pro' );?></label>
                </th>
                <td>
                    <select class="ua_select product_includes_excludes" id="product_id_includes" name="basics[post_include][]" data-name="post_include" multiple="multiple">
                        <?php echo $post_include; ?>
                    </select>
                    <p><?php echo esc_html__( 'Choose your selected product to make a table with selected product from your while store. To select multiple products at a time, Please press [CTRL + S]', 'wpt_pro') ?></p>
                </td>
            </tr>
            <tr>
                <th>
                    <label class="wpt_label"><?php esc_html_e( 'Product Exclude', 'wpt_pro' );?></label>
                </th>
                <td>
                    <select class="ua_select product_includes_excludes" id="product_id_cludes" name="basics[post_exclude][]" data-name="post_exclude" multiple="multiple">
                        <?php echo $post_exclude; ?>
                    </select>
                </td>
            </tr>
        </table>
    </div>
       <?php

    }
}
add_action( 'wpto_admin_basic_tab', 'wpto_pro_product_incld_excld_basic_tab', 10 );


if( !function_exists( 'wpto_pro_search_from' ) ){
    

    function wpto_pro_search_from( $meta_search_n_filter, $post ){

       ?>
        <table class="ultraaddons-table wpt_snf_on_off">
            <tr>
                <th>
                    <label class="wpt_label"><?php esc_html_e( 'Search From', 'wpt_pro' ); ?></label>
                </th>
                <td>
                    <ul class="wpt-tag-list">
                    <?php
                    $search_form_arr = array(
                        'ID' => 'posts',
                        'post_title' => 'posts',
                        'post_content' => 'posts',
                        'menu_order' => 'posts',
                        'post_author' => 'posts',
                        'post_excerpt' => 'posts',
                        'post_parent' => 'posts',
                        'post_name' => 'posts',
                        'post_date' => 'posts',
                        '_sku' => 'postmeta',
                        '_price' => 'postmeta',
                        '_regular_price' => 'postmeta',
                        '_sale_price' => 'postmeta',
                        '_sku' => 'postmeta',
                    );
                    $search_form_arr = apply_filters( 'wpto_admin_search_from_arr', $search_form_arr, $post, $meta_search_n_filter );

                    foreach($search_form_arr as $search_key => $search_type){
                        ?>  
                        <li class="wpt_checkbox wpt_search_form_checkbox wpt_<?php esc_attr_e( $search_key ); ?>_checkbox">
                            <input type="checkbox" name="search_n_filter[search_from][<?php esc_attr_e( $search_key ); ?>]" id="search_from_<?php esc_attr_e( $search_key ); ?>" value="<?php esc_attr_e( $search_type ); ?>" <?php echo isset( $meta_search_n_filter['search_from'][$search_key] ) && !empty( $meta_search_n_filter['search_from']) ? 'checked' : ''; ?>>
                            <label for="search_from_<?php esc_attr_e( $search_key ); ?>"><?php esc_html_e( $search_key ); ?></label>
                        </li>
                    <?php
                    }
                    ?>    
                    </ul>
                </td>
            </tr>
        </table>
       <?php

    }
}
add_action( 'wpto_admin_search_n_filter_tab', 'wpto_pro_search_from', 10, 2 );


