<?php

/**
 * Executing selected item for options
 * 
 * @since 2.4 
 */
function wpt_selected( $keyword, $gotten_value ){
    $current_config_value = get_option('wpt_configure_options');
    echo ( isset( $current_config_value[$keyword] ) && $current_config_value[$keyword] == $gotten_value ? 'selected' : false );
}

/**
 * For Configuration Page
 * 
 * @since 2.4
 */
function wpt_configuration_page(){
    //var_dump($_POST);
    if( isset( $_POST['data'] ) && isset( $_POST['reset_button'] ) ){
        $value = WOO_Product_Table::$default;
        //var_dump($value);
        update_option( 'wpt_configure_options', $value );
       
    }else if( isset( $_POST['data'] ) && isset( $_POST['configure_submit'] ) ){
        //configure_submit
        $value = ( is_array( $_POST['data'] ) ? $_POST['data'] : false );
        update_option( 'wpt_configure_options', $value);
    }
    $current_config_value = get_option('wpt_configure_options');

    //var_dump($current_config_value);
    ?>
    <div class="wrap wpt_wrap wpt_configure_page">
        <h2 class="plugin_name"><?php echo WOO_Product_Table::getName(); ?> <span class="plugin_version">v <?php echo WOO_Product_Table::getVersion(); ?></span> </h2>
        <hr>
        <h1>Configuration Default Value</h1>
        <div id="wpt_configuration_form" class="wpt_leftside">
            <div style="padding-top: 15px;padding-bottom: 15px;" class="fieldwrap wpt_result_footer">
                <form action="" method="POST">
                    
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_sort_mini_filter">Mini Filter Sorting</label>
                        <select name="data[sort_mini_filter]" id="wpt_table_sort_mini_filter" class="wpt_fullwidth" >
                            <option value="0" <?php wpt_selected('sort_mini_filter', '0');?>>None</option>
                            <option value="ASC" <?php wpt_selected('sort_mini_filter', 'ASC');?>>Assending</option>
                            <option value="DESC" <?php wpt_selected('sort_mini_filter', 'DESC');?>>Descending</option>
                        </select>
                    </div>
                    
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_thumbs_image_size">Thumbs Image Size</label>
                        <select name="data[thumbs_image_size]" id="wpt_table_thumbs_image_size" class="wpt_fullwidth" >
                            <option value="30" <?php wpt_selected('thumbs_image_size', '30');?>>30 x 30 px</option>
                            <option value="56" <?php wpt_selected('thumbs_image_size', '56');?>>56 x 56 px</option>
                            <option value="100" <?php wpt_selected('thumbs_image_size', '100');?>>100 x 100 px</option>
                            <option value="200" <?php wpt_selected('thumbs_image_size', '200');?>>200 x 200 px</option>
                            <option value="400" <?php wpt_selected('thumbs_image_size', '400');?>>400 x 400 px</option>
                            <option value="500" <?php wpt_selected('thumbs_image_size', '500');?>>500 x 500 px</option>
                            <option value="800" <?php wpt_selected('thumbs_image_size', '800');?>>800 x 800 px</option>
                        </select>
                    </div>
                    
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_disable_product_link">Disable Product Link</label>
                        <select name="data[disable_product_link]" id="wpt_table_disable_product_link" class="wpt_fullwidth" >
                            <option value="1" <?php wpt_selected('disable_product_link', '1');?>>Yes</option>
                            <option value="0" <?php wpt_selected('disable_product_link', '0');?>>No</option>
                        </select>
                    </div>
                    
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_product_link_target">Disable Product Link</label>
                        <select name="data[product_link_target]" id="wpt_table_disable_product_link" class="wpt_fullwidth" >
                            <option value="_blank" <?php wpt_selected('product_link_target', '_blank');?>>New Tab</option>
                            <option value="_self" <?php wpt_selected('product_link_target', '_self');?>>Self Tab</option>
                        </select>
                    </div>
                    
                    
                    <div class="wpt_column">
                        <label for="wpt_table_load_more_text" class="wpt_label"><b>[Load More]</b> - Button Text</label>
                        <input name="data[load_more_text]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['load_more_text']; ?>" id="wpt_table_load_more_text" type="text" placeholder="Load More text write here">
                    </div>
                    
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_disable_loading_more">Disable <b>[Load More]</b> Button</label>
                        <select name="data[disable_loading_more]" id="wpt_table_disable_loading_more" class="wpt_fullwidth" >
                            <option value="load_more_hidden" <?php wpt_selected('disable_loading_more', 'load_more_hidden');?>>Yes</option>
                            <option value="normal" <?php wpt_selected('disable_loading_more', 'normal');?>>No</option>
                        </select>
                    </div>
                    
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_instant_search_filter">Instant Search Filter</label>
                        <select name="data[instant_search_filter]" id="wpt_table_instant_search_filter" class="wpt_fullwidth" >
                            <option value="1" <?php wpt_selected('instant_search_filter', '1');?>>Yes</option>
                            <option value="0" <?php wpt_selected('instant_search_filter', '0');?>>No</option>
                        </select>
                    </div>
                    <div class="wpt_column">
                        <label for="wpt_table_instant_search_textt" class="wpt_label"><b>[Instance Search]</b> - Text</label>
                        <input name="data[instant_search_text]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['instant_search_text']; ?>" id="wpt_table_instant_search_text" type="text" placeholder="Instance Search text write here">
                    </div>
                    
                    
                    
                    
                    <button type="submit" name="configure_submit" class="button-primary primary button btn-info">Submit</button>
                    <button type="submit" name="reset_button" class="button">Reset</button>
                    
                </form>
            </div>
            
            
            
        </div>
        <!-- Right Side start here -->
        <div class="wpt_rightside">
            <div class="wpt_right_side_in_wrapper" style="padding: 10px;">
                <div class="need_help_wrapper">
                    <h1>Need Help?</h1>
                    <span>Email: <a href="mailto:codersaiful@gmail.com?subject=Need Plugin Help&body=I need help for Woo Product Table Plugin for the issue ....." target="_top">codersaiful@gmail.com</a></span>
                    <span>Skype: <a href="#">codersaiful</a></span>
                    <span>Facebook: <a href="https://www.facebook.com/messages/t/codersaiful" target="_blank">fb.com/codersaiful</a></span>
                    <span>Youtube: <a href="https://www.youtube.com/user/codersaiful" target="_blank">Plugin's Tutorial</a></span>
                </div>
            </div>
            
            <div class="wpt_right_side_in_wrapper" style="padding: 10px;">
                <div class="rate_us_wrapper">
                    <a href="https://codecanyon.net/downloads" target="_blank"><img class="rate_us_image" src="<?php echo WOO_Product_Table::getPath('BASE_URL'); ?>images/rate_us.png"></a>
                    <h1>It can take only 2 Minutes.</h1>
                    <h3><a href="<?php echo WOO_Product_Table::getPath('BASE_URL'); ?>images/rate_us_tutorial_2.jpg" target="_blank">See Screenshot</a></h3>
                </div>
            </div>
            
        </div>     
    </div>  
    
    <style>
        .tab-content{display: none;}
        .tab-content.tab-content-active{display: block;}
        .wpt_leftside,.wpt_rightside{float: left;}
        .wpt_leftside{
            width: 75%;
        }
        .break_space_large{display: block;visibility: hidden;height: 25px;background: transparent;}
        .break_space,.break_space_medium{display: block;visibility: hidden;height: 15px;background: transparent;}
        .break_space_small{display: block;visibility: hidden;height: 5px;background: transparent;}
        .wpt_rightside{width: 25%;}
        @media only screen and (max-width: 800px){
            .wpt_leftside{width: 100%;}
            .wpt_rightside{display: none !important;}
        }
        /*****For Column Moveable Item*******/
        ul#wpt_column_sortable li>span.handle{
            background-image: url('<?php echo WPT_BASE_URL . 'images/move.png'; ?>');
        }

    </style>
    <?php
}